package ch.hslu.appe.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.eclipse.wb.swing.FocusTraversalOnArray;

import ch.hslu.appe.gui.model.AddressTableModel;
import ch.hslu.appe.gui.model.CustomerTableModel;
import ch.hslu.appe.usermanagement.webservice.AddressDto;
import ch.hslu.appe.usermanagement.webservice.IllegalNameException_Exception;
import ch.hslu.appe.usermanagement.webservice.UserDto;
import ch.hslu.appe.usermanagement.webservice.UserState;
import ch.hslu.appe.webservice.consumer.UserManagementConsumerImpl;
import java.awt.event.InputMethodListener;
import java.awt.event.InputMethodEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.CaretEvent;

/**
 * Customer Management GUI.
 */
@SuppressWarnings("serial")
public class customerManagement extends JDialog {

    private final FlowLayout flowLayout;
    private final FlowLayout flowLayoutBottom;
    private final JButton buttonAddressSave;
    private final JButton buttonAddressAdd;
    private final JButton buttonAddressDelete;
    private final JButton buttonBack;
    private final JButton buttonCancel;
    private final JButton buttonCustomerAdd;
    private final JButton buttonCustomerDel;
    private final JButton buttonCustomerOk;
    private final JButton buttonEnd;
    private final JButton buttonFront;
    private final JButton buttonForward;
    private final JButton buttonOK;
    private final JComboBox comboBoxAddressOption;
    private final JComboBox comboBoxSalutation;
    private final JComboBox comboBoxRole;
    private final JComboBox comboBoxState;
    private final JLabel labelCustomerNr;
    private final JLabel labelSalutation;
    private final JLabel labelPrename;
    private final JLabel labelName;
    private final JLabel labelRole;
    private final JLabel labelState;
    private final JLabel labelUsername;
    private final JLabel labelStreet;
    private final JLabel labelZIP;
    private final JLabel labelLocation;
    private final JLabel labelPassword;
    private final JPanel panelBottom;
    private final JPanel panelContent;
    private final JPanel panelSearch;
    private final JPanel panelAddress;
    private final JPanel panelMain;
    private final JPanel panelAddressMain;
    private final JPanel panelCustomer;
    private final JPasswordField passwordFieldCustomer;
    private final JScrollPane scrollPaneCustomer;
    private final JScrollPane scrollPaneAddress;
    private final JTabbedPane tabbedPaneCustomer;
    private final JTable tableAddress;
    private final JTable tableCustomer;
    private final JTextField textFieldCustomerNr;
    private final JTextField textFieldLocation;
    private final JTextField textFieldName;
    private final JTextField textFieldPrename;
    private final JTextField textFieldStreet;
    private final JTextField textFieldUsername;
    private final JTextField textFieldZIP;
    private final CustomerTableModel customerTableModel;
    private final AddressTableModel addressTableModel;
    private static customerManagement customerManagementFrame;
    private final JTextField textFieldAddressNr;
    private UserDto user;
    private int lastUserId = -1;

    /**
     * Create the frame.
     */
    public customerManagement() {

        // General
        setTitle("Kundenverwaltung");
        setModal(true);
        setBounds(100, 100, 682, 470);

        // Main Panel
        panelMain = new JPanel();
        panelMain.setBorder(new EmptyBorder(5, 5, 5, 5));
        panelMain.setLayout(new BorderLayout(0, 0));
        setContentPane(panelMain);

        // Search Panel
        panelSearch = new JPanel();
        flowLayout = (FlowLayout) panelSearch.getLayout();
        flowLayout.setAlignment(FlowLayout.RIGHT);
        panelMain.add(panelSearch, BorderLayout.NORTH);

        // Search: back to first element Button
        buttonFront = new JButton("<<");
        buttonFront.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                tableCustomer.changeSelection(0, 0, false, false);
            }
        });
        buttonFront.setMargin(new Insets(2, 2, 2, 2));
        buttonFront.setPreferredSize(new Dimension(35, 23));
        panelSearch.add(buttonFront);

        // Search: back Panel
        buttonBack = new JButton("<");
        buttonBack.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent arg0) {
                // true --> back
                changeRowSelection(true);
            }
        });
        buttonBack.setMargin(new Insets(2, 2, 2, 2));
        buttonBack.setPreferredSize(new Dimension(35, 23));
        panelSearch.add(buttonBack);

        // Search: Forward Button
        buttonForward = new JButton(">");
        buttonForward.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                // false --> forward
                changeRowSelection(false);
            }
        });
        buttonForward.setMargin(new Insets(2, 2, 2, 2));
        buttonForward.setPreferredSize(new Dimension(35, 23));
        panelSearch.add(buttonForward);

        // Search: forward to the last element Button
        buttonEnd = new JButton(">>");
        buttonEnd.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                tableCustomer.changeSelection(tableCustomer.getRowCount() - 1, 0, false, false);
            }
        });
        buttonEnd.setMargin(new Insets(2, 2, 2, 2));
        buttonEnd.setPreferredSize(new Dimension(35, 23));
        panelSearch.add(buttonEnd);

        // Bottom Panel
        panelBottom = new JPanel();
        flowLayoutBottom = (FlowLayout) panelBottom.getLayout();
        flowLayoutBottom.setAlignment(FlowLayout.RIGHT);
        panelMain.add(panelBottom, BorderLayout.SOUTH);

        // Bottom: Cancel Button
        buttonCancel = new JButton("Abbrechen");
        buttonCancel.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                setVisible(false);
                dispose();
            }
        });
        panelBottom.add(buttonCancel);

        // Bottom: OK Button
        buttonOK = new JButton("OK");
        buttonOK.setEnabled(false);
        buttonOK.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent arg0) {
                user = UserManagementConsumerImpl.getInstance()
                        .getUserById(Integer.parseInt(textFieldCustomerNr.getText()));
                setVisible(false);
                dispose();
            }
        });
        buttonOK.setPreferredSize(new Dimension(85, 23));
        panelBottom.add(buttonOK);

        // Content Panel
        panelContent = new JPanel();
        panelMain.add(panelContent, BorderLayout.CENTER);
        panelContent.setLayout(new BorderLayout(0, 0));

        // TabbedPane: Address Table
        addressTableModel = new AddressTableModel();
        tableAddress = new JTable(addressTableModel);
        tableAddress.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        tableAddress.setPreferredScrollableViewportSize(new Dimension(500, 65));
        tableAddress.setFillsViewportHeight(true);
        tableAddress.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(final ListSelectionEvent e) {
                int id = (int) addressTableModel.getValueAt(tableAddress.getSelectedRow(), 0);
                selectAddress(id);
            }
        });

        // Content: Customer Table
        customerTableModel = new CustomerTableModel();
        tableCustomer = new JTable(customerTableModel);
        tableCustomer.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        tableCustomer.setPreferredScrollableViewportSize(new Dimension(500, 70));
        tableCustomer.setFillsViewportHeight(true);
        tableCustomer.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(final ListSelectionEvent e) {
                // Get id from user
                int id = (int) customerTableModel.getValueAt(tableCustomer.getSelectedRow(), 0);
                lastUserId = id;

                selectUser(id);

                // Refresh AddressTable
                addressTableModel.generateTableData(id);
                tableAddress.repaint();
            }
        });

        // Content: ScrollPane
        scrollPaneCustomer = new JScrollPane(tableCustomer);
        scrollPaneCustomer.setPreferredSize(new Dimension(519, 105));
        panelContent.add(scrollPaneCustomer, BorderLayout.NORTH);

        // Content: TabbedPane Customer
        tabbedPaneCustomer = new JTabbedPane(JTabbedPane.TOP);
        panelContent.add(tabbedPaneCustomer, BorderLayout.CENTER);

        // TabbedPane: Customer Panel
        panelCustomer = new JPanel();
        tabbedPaneCustomer.addTab("Kunde", null, panelCustomer, null);
        panelCustomer.setLayout(null);

        // TabbedPane: CustomerNr Label
        labelCustomerNr = new JLabel("Kunden Nr.");
        labelCustomerNr.setBounds(10, 22, 75, 14);
        panelCustomer.add(labelCustomerNr);

        // TabbedPane: Salutation Label
        labelSalutation = new JLabel("Anrede");
        labelSalutation.setBounds(10, 58, 55, 14);
        panelCustomer.add(labelSalutation);

        // TabbedPane: Prename Label
        labelPrename = new JLabel("Vorname");
        labelPrename.setBounds(10, 97, 61, 14);
        panelCustomer.add(labelPrename);

        // TabbedPane: Name Label
        labelName = new JLabel("Name");
        labelName.setBounds(10, 137, 55, 14);
        panelCustomer.add(labelName);

        // TabbedPane: Role Label
        labelRole = new JLabel("Rolle");
        labelRole.setBounds(225, 22, 33, 14);
        panelCustomer.add(labelRole);

        // TabbedPane: State Label
        labelState = new JLabel("Status");
        labelState.setBounds(225, 58, 39, 14);
        panelCustomer.add(labelState);

        // TabbedPane: Username Label
        labelUsername = new JLabel("Benutzername");
        labelUsername.setBounds(408, 22, 83, 14);
        panelCustomer.add(labelUsername);

        // TabbedPane: Password Label
        labelPassword = new JLabel("Passwort");
        labelPassword.setBounds(408, 58, 83, 14);
        panelCustomer.add(labelPassword);

        // TabbedPane: CustomerNr TextField
        textFieldCustomerNr = new JTextField();
        textFieldCustomerNr.addCaretListener(new CaretListener() {
            public void caretUpdate(final CaretEvent arg0) {
                buttonOK.setEnabled(true);
                if (textFieldCustomerNr.getText().isEmpty()) {
                    buttonOK.setEnabled(false);
                }
            }
        });
        textFieldCustomerNr.setEditable(false);
        textFieldCustomerNr.setBounds(91, 19, 124, 20);
        panelCustomer.add(textFieldCustomerNr);
        textFieldCustomerNr.setColumns(10);

        // TabbedPane: Prename TextField
        textFieldPrename = new JTextField();
        textFieldPrename.setColumns(10);
        textFieldPrename.setBounds(91, 94, 124, 20);
        panelCustomer.add(textFieldPrename);

        // TabbedPane: Name TextField
        textFieldName = new JTextField();
        textFieldName.setColumns(10);
        textFieldName.setBounds(91, 134, 124, 20);
        panelCustomer.add(textFieldName);

        // TabbedPane: Username TextField
        textFieldUsername = new JTextField();
        textFieldUsername.setColumns(10);
        textFieldUsername.setBounds(501, 19, 124, 20);
        panelCustomer.add(textFieldUsername);

        // TabbedPane: PasswordField
        passwordFieldCustomer = new JPasswordField();
        passwordFieldCustomer.setBounds(501, 55, 124, 20);
        panelCustomer.add(passwordFieldCustomer);

        // TabbedPane: ComboBox Salutation
        String[] salutaionOptions = {"Herr", "Frau" };
        comboBoxSalutation = new JComboBox(salutaionOptions);
        comboBoxSalutation.setBounds(91, 55, 124, 20);
        panelCustomer.add(comboBoxSalutation);

        // TabbedPane: ComboBox Role
        String[] roleOptions = {"customer", "admin", "manager", "accountexecutive", "stockman" };
        comboBoxRole = new JComboBox(roleOptions);
        comboBoxRole.setBounds(274, 19, 124, 20);
        panelCustomer.add(comboBoxRole);

        // TabbedPane: ComboBox State
        String[] stateOptions = {"BLOCKED", "ACTIVE", "DELETED" };
        comboBoxState = new JComboBox(stateOptions);
        comboBoxState.setBounds(274, 55, 124, 20);
        panelCustomer.add(comboBoxState);

        // TabbedPane: Add Button
        buttonCustomerAdd = new JButton("");
        buttonCustomerAdd.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                newUser();
            }
        });
        buttonCustomerAdd.setMargin(new Insets(0, 0, 0, 0));
        buttonCustomerAdd.setContentAreaFilled(false);
        buttonCustomerAdd.setBorderPainted(false);
        buttonCustomerAdd.setBorder(null);
        buttonCustomerAdd.setIcon(new ImageIcon(this.getClass().getResource("../img/add_small.png")));
        buttonCustomerAdd.setBounds(530, 129, 25, 25);
        panelCustomer.add(buttonCustomerAdd);

        // TabbedPane: OK Button
        buttonCustomerOk = new JButton("");
        buttonCustomerOk.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                editUser();
            }
        });
        buttonCustomerOk.setMargin(new Insets(0, 0, 0, 0));
        buttonCustomerOk.setContentAreaFilled(false);
        buttonCustomerOk.setBorderPainted(false);
        buttonCustomerOk.setBorder(null);
        buttonCustomerOk.setIcon(new ImageIcon(this.getClass().getResource("../img/ok_small.png")));
        buttonCustomerOk.setBounds(565, 129, 25, 25);
        panelCustomer.add(buttonCustomerOk);

        // TabbedPane: Del Button
        buttonCustomerDel = new JButton("");
        buttonCustomerDel.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                deleteUser();
            }
        });
        buttonCustomerDel.setMargin(new Insets(0, 0, 0, 0));
        buttonCustomerDel.setContentAreaFilled(false);
        buttonCustomerDel.setBorderPainted(false);
        buttonCustomerDel.setBorder(null);
        buttonCustomerDel.setIcon(new ImageIcon(this.getClass().getResource("../img/del_small.png")));
        buttonCustomerDel.setBounds(600, 129, 25, 25);
        panelCustomer.add(buttonCustomerDel);
        panelCustomer.setFocusTraversalPolicy(new FocusTraversalOnArray(new Component[] {textFieldCustomerNr,
                comboBoxSalutation, textFieldPrename, textFieldName, comboBoxRole, comboBoxState, textFieldUsername,
                passwordFieldCustomer, buttonCustomerAdd, buttonCustomerOk, buttonCustomerDel }));

        // Content: TabbedPane Address
        panelAddress = new JPanel();
        tabbedPaneCustomer.addTab("Adresse", null, panelAddress, null);
        panelAddress.setLayout(new BorderLayout(0, 0));

        // TabbedPane: Address ScrollPane
        scrollPaneAddress = new JScrollPane(tableAddress);
        scrollPaneAddress.setPreferredSize(new Dimension(519, 71));

        // TabbedPane: Address Panel
        panelAddress.add(scrollPaneAddress, BorderLayout.SOUTH);

        // TabbedPane: Address Main Panel
        panelAddressMain = new JPanel();
        panelAddress.add(panelAddressMain, BorderLayout.CENTER);
        panelAddressMain.setLayout(null);

        // TabbedPane: Street Label
        labelStreet = new JLabel("Strasse");
        labelStreet.setBounds(10, 73, 58, 14);
        panelAddressMain.add(labelStreet);

        // TabbedPane: Street TextField
        textFieldStreet = new JTextField();
        textFieldStreet.setColumns(10);
        textFieldStreet.setBounds(80, 70, 200, 20);
        panelAddressMain.add(textFieldStreet);

        // TabbedPane: AddressOtion ComboBox
        String[] addressOption = {"Lieferadresse", "Rechnunsadresse" };
        comboBoxAddressOption = new JComboBox(addressOption);
        comboBoxAddressOption.setBounds(80, 26, 200, 20);
        panelAddressMain.add(comboBoxAddressOption);

        // TabbedPane: ZIP Label
        labelZIP = new JLabel("PLZ");
        labelZIP.setBounds(10, 109, 58, 14);
        panelAddressMain.add(labelZIP);

        // TabbedPane: ZIP TextField
        textFieldZIP = new JTextField();
        textFieldZIP.setColumns(10);
        textFieldZIP.setBounds(80, 106, 53, 20);
        panelAddressMain.add(textFieldZIP);

        // TabbedPane: Location Label
        labelLocation = new JLabel("Ort");
        labelLocation.setBounds(143, 109, 25, 14);
        panelAddressMain.add(labelLocation);

        // TabbedPane: Location TextField
        textFieldLocation = new JTextField();
        textFieldLocation.setColumns(10);
        textFieldLocation.setBounds(176, 106, 104, 20);
        panelAddressMain.add(textFieldLocation);

        // TabbedPane: AddressSave Button
        buttonAddressSave = new JButton("");
        buttonAddressSave.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                editAddress();
            }
        });
        buttonAddressSave.setContentAreaFilled(false);
        buttonAddressSave.setBorder(null);
        buttonAddressSave.setBorderPainted(false);
        buttonAddressSave.setMargin(new Insets(0, 0, 0, 0));
        buttonAddressSave.setIcon(new ImageIcon(this.getClass().getResource("../img/ok_small.png")));
        buttonAddressSave.setBounds(581, 115, 25, 25);
        panelAddressMain.add(buttonAddressSave);

        // TabbedPane: AddressAdd Button
        buttonAddressAdd = new JButton("");
        buttonAddressAdd.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent arg0) {
                newAddress();
            }
        });
        buttonAddressAdd.setContentAreaFilled(false);
        buttonAddressAdd.setBorderPainted(false);
        buttonAddressAdd.setBorder(null);
        buttonAddressAdd.setIcon(new ImageIcon(this.getClass().getResource("../img/add_small.png")));
        buttonAddressAdd.setMargin(new Insets(0, 0, 0, 0));
        buttonAddressAdd.setBounds(546, 115, 25, 25);
        panelAddressMain.add(buttonAddressAdd);

        // TabbedPane: AddressDelete Button
        buttonAddressDelete = new JButton("");
        buttonAddressDelete.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                deletAddress();
            }
        });
        buttonAddressDelete.setContentAreaFilled(false);
        buttonAddressDelete.setBorderPainted(false);
        buttonAddressDelete.setBorder(null);
        buttonAddressDelete.setIcon(new ImageIcon(this.getClass().getResource("../img/del_small.png")));
        buttonAddressDelete.setMargin(new Insets(0, 0, 0, 0));
        buttonAddressDelete.setBounds(616, 115, 25, 25);
        panelAddressMain.add(buttonAddressDelete);

        textFieldAddressNr = new JTextField();
        textFieldAddressNr.setEnabled(false);
        textFieldAddressNr.setEditable(false);
        textFieldAddressNr.setAutoscrolls(false);
        textFieldAddressNr.setBounds(10, 26, 58, 20);
        panelAddressMain.add(textFieldAddressNr);
        textFieldAddressNr.setColumns(10);
        panelAddressMain.setFocusTraversalPolicy(new FocusTraversalOnArray(new Component[] {textFieldStreet,
                textFieldZIP, textFieldLocation, comboBoxAddressOption, buttonAddressAdd, buttonAddressSave,
                buttonAddressDelete }));
    }

    /**
     * getUser.
     * @return user
     */
    public final UserDto getUser() {
        return user;
    }

    /**
     * Change the selected Row.
     * @param back Back or forward
     */
    private void changeRowSelection(final boolean back) {

        // Get the index of the selected row
        int rowIndex = tableCustomer.getSelectedRow();

        // By the first and last element: change rowIndex
        if (back && rowIndex > 0) {
            rowIndex -= 1;
        } else if (!back && rowIndex < tableCustomer.getRowCount() - 1) {
            rowIndex += 1;
        }

        // Change selection
        tableCustomer.changeSelection(rowIndex, 0, false, false);
    }

    /**
     * Delete address.
     */
    private void deletAddress() {

        // Get addressId
        int addressId = Integer.parseInt(textFieldAddressNr.getText());

        // Get address
        AddressDto address = UserManagementConsumerImpl.getInstance().getAddress(addressId);

        // If address is null then throw a error
        if (address == null) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim selektieren der Adresse aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }

        // Message before delete the user
        int response = JOptionPane.showConfirmDialog(null, "Wollen Sie die Adresse wirklich löschen?",
                "Adresse löschen", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);

        // Message after the action
        if (response == JOptionPane.NO_OPTION || response == JOptionPane.CLOSED_OPTION) {
            // Message
            JOptionPane.showMessageDialog(null, "Die Adresse wurde NICHT gelöscht!", "Info",
                    JOptionPane.INFORMATION_MESSAGE);
        } else if (response == JOptionPane.YES_OPTION) {
            // Delete the user
            UserManagementConsumerImpl.getInstance().deleteAddress(addressId);

            // Refresh AddressTable
            addressTableModel.generateTableData(Integer.parseInt(textFieldCustomerNr.getText()));
            tableAddress.repaint();

            // Message after deleting
            JOptionPane.showMessageDialog(null, "Der Kunde wurde gelöscht!", "Info", JOptionPane.INFORMATION_MESSAGE);
        }
    }

    /**
     * Delete User.
     */
    private void deleteUser() {

        // Get userId
        int userId = Integer.parseInt(textFieldCustomerNr.getText());

        // Get User
        UserDto deleteUser = UserManagementConsumerImpl.getInstance().getUserById(userId);

        // If user is null then throw a error
        if (deleteUser == null) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim selektieren des Users aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }

        // Message before delete the user
        int response = JOptionPane.showConfirmDialog(null, "Wollen Sie den Kunden wirklich l\u00F6schen?",
                "Kunde l\u00F6schen", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);

        // Message after the action
        if (response == JOptionPane.NO_OPTION || response == JOptionPane.CLOSED_OPTION) {
            // Message
            JOptionPane.showMessageDialog(null, "Der Kunde wurde NICHT gelöscht!", "Info",
                    JOptionPane.INFORMATION_MESSAGE);
        } else if (response == JOptionPane.YES_OPTION) {
            // Delete the user
            UserManagementConsumerImpl.getInstance().deleteUser(userId);

            // Refresh Table
            customerTableModel.generateTableData();
            tableCustomer.repaint();

            // Message after deleting
            JOptionPane.showMessageDialog(null, "Der Kunde wurde gelöscht!", "Info", JOptionPane.INFORMATION_MESSAGE);
        }
    }

    /**
     * Edit address.
     */
    private void editAddress() {

        int addressId;

        // Read UserId
        if (textFieldAddressNr.getText().isEmpty()) {
            addressId = 0;
        } else {
            addressId = Integer.parseInt(textFieldAddressNr.getText());
        }

        // Is userId not 0 then edit the address, otherwise create a address
        if (addressId != 0) {

            // get the address
            AddressDto address = UserManagementConsumerImpl.getInstance().getAddress(addressId);

            // Is the address null then throw an exception
            if (address == null) {
                JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim selektieren der Adresse aufgetreten!",
                        "ERROR", JOptionPane.ERROR_MESSAGE);
                return;
            }

            // MessageBox before save the address
            int response = JOptionPane.showConfirmDialog(null, "Wollen Sie die Adressänderung mit der ID '" + addressId
                    + "' speichern?", "Adresse speichern", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);

            if (response == JOptionPane.NO_OPTION || response == JOptionPane.CLOSED_OPTION) {
                // Message after failed action
                JOptionPane.showMessageDialog(null, "Änderungen wurden verworfen!", "Info",
                        JOptionPane.INFORMATION_MESSAGE);
            } else if (response == JOptionPane.YES_OPTION) {

                // Save the changes in AddressDTO
                address.setPlace(textFieldLocation.getText());
                address.setStreet(textFieldStreet.getText());
                address.setZipCode(Integer.parseInt(textFieldZIP.getText()));
                address.setType(comboBoxAddressOption.getSelectedIndex());

                // Update address
                UserManagementConsumerImpl.getInstance().updateAddress(address);

                // Refresh AddressTable
                addressTableModel.generateTableData(Integer.parseInt(textFieldCustomerNr.getText()));
                tableAddress.repaint();

                // Message after update
                JOptionPane.showMessageDialog(null, "Änderungen wurden gespeichert!", "Info",
                        JOptionPane.INFORMATION_MESSAGE);
            }
        } else {
            AddressDto newAddress = new AddressDto();

            newAddress.setPlace(textFieldLocation.getText());
            newAddress.setStreet(textFieldStreet.getText());
            newAddress.setZipCode(Integer.parseInt(textFieldZIP.getText()));
            newAddress.setType(comboBoxAddressOption.getSelectedIndex());

            if (lastUserId == -1) {
                JOptionPane.showMessageDialog(null,
                        "Bitte wähle zuerst einen Benutzer aus, dem die Adresse zugewiesen werden soll", "ERROR",
                        JOptionPane.ERROR_MESSAGE);
                return;
            }

            if (UserManagementConsumerImpl.getInstance().addAddress(lastUserId, newAddress)) {

                // Refresh AddressTable
                addressTableModel.generateTableData(lastUserId);
                tableAddress.repaint();

                JOptionPane.showMessageDialog(null, "Adresse wurde erstellt!", "Info", JOptionPane.INFORMATION_MESSAGE);
            } else {
                JOptionPane.showMessageDialog(null, "Adresse konnte NICHT erstellt werden!", "ERROR",
                        JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    /**
     * editUser.
     */
    private void editUser() {

        int userId;

        // Read UserId
        if (textFieldCustomerNr.getText().isEmpty()) {
            userId = 0;
        } else {
            userId = Integer.parseInt(textFieldCustomerNr.getText());
        }
        // read password
        String newPwd = new String(passwordFieldCustomer.getPassword());

        // Is userId not 0 then editUser, otherwise create a new user
        if (userId != 0) {

            // get the user
            UserDto editUser = UserManagementConsumerImpl.getInstance().getUserById(userId);

            // when the user is null then throw an exception
            if (editUser == null) {
                JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim selektieren des Users aufgetreten!",
                        "ERROR", JOptionPane.ERROR_MESSAGE);
                return;
            }

            // MessageBox before save the customer
            int response = JOptionPane.showConfirmDialog(null, "Wollen Sie die Änderungen des Kunden mit der ID '"
                    + userId + "' speichern?", "Kunde speichern", JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE);

            try {
                if (response == JOptionPane.NO_OPTION || response == JOptionPane.CLOSED_OPTION) {
                    // Message after failed action
                    JOptionPane.showMessageDialog(null, "Änderungen wurden verworfen!", "Info",
                            JOptionPane.INFORMATION_MESSAGE);
                } else if (response == JOptionPane.YES_OPTION) {

                    // Save the changes in UserDTO
                    editUser.setPrename(textFieldPrename.getText());
                    editUser.setSurname(textFieldName.getText());
                    editUser.setSalutation(comboBoxSalutation.getSelectedItem().toString());
                    editUser.setRole(comboBoxRole.getSelectedItem().toString());
                    editUser.setState(getUserState(comboBoxState.getSelectedItem().toString()));
                    editUser.setLogin(textFieldUsername.getText());

                    // check if we need to set a new password
                    if (!newPwd.isEmpty()) {
                        editUser.setPassword(newPwd);
                    }

                    // Update user
                    UserManagementConsumerImpl.getInstance().updateUser(editUser);

                    // Refresh Table
                    customerTableModel.generateTableData();
                    tableCustomer.repaint();

                    // Message after update
                    JOptionPane.showMessageDialog(null, "Änderungen wurden gespeichert!", "Info",
                            JOptionPane.INFORMATION_MESSAGE);
                }
            } catch (IllegalNameException_Exception e) {
                JOptionPane.showMessageDialog(null, "Loginname ist nicht korrekt!", "ERROR", JOptionPane.ERROR_MESSAGE);
            }
        } else {
            UserDto newUser = new UserDto();

            newUser.setLogin(textFieldUsername.getText());
            newUser.setPassword(newPwd);
            newUser.setSurname(textFieldName.getText());
            newUser.setPrename(textFieldPrename.getText());
            newUser.setSalutation(comboBoxSalutation.getSelectedItem().toString());
            newUser.setRole(comboBoxRole.getSelectedItem().toString());
            newUser.setState(getUserState(comboBoxState.getSelectedItem().toString()));

            try {
                if (UserManagementConsumerImpl.getInstance().addUser(newUser)) {
                    // Refresh Table
                    customerTableModel.generateTableData();
                    tableCustomer.repaint();

                    JOptionPane.showMessageDialog(null, "Benutzer wurde erstellt!", "Info",
                            JOptionPane.INFORMATION_MESSAGE);
                } else {
                    JOptionPane.showMessageDialog(null, "Benutzer konnte NICHT erstellt werden!", "ERROR",
                            JOptionPane.ERROR_MESSAGE);
                }
            } catch (IllegalNameException_Exception e) {
                JOptionPane.showMessageDialog(null, "Loginname ist nicht korrekt!", "ERROR", JOptionPane.ERROR_MESSAGE);
            }

        }
    }

    /**
     * Gets the UserRole ID.
     * @param userRole userRole
     * @return UserRole ID
     */
    private int getUserRoleID(final String userRole) {
        int userRoleID;

        switch (userRole) {
        case "customer":
            userRoleID = 0;
            break;
        case "admin":
            userRoleID = 1;
            break;
        case "manager":
            userRoleID = 2;
            break;
        case "accountexecutive":
            userRoleID = 3;
            break;
        case "stockman":
            userRoleID = 4;
            break;
        default:
            userRoleID = 0;
            break;
        }

        return userRoleID;
    }

    /**
     * gets the User ID Salutation.
     * @param userSalutation userSalution
     * @return Salutation ID
     */
    private int getUserSalutationID(final String userSalutation) {
        int userSalutationID;

        if (userSalutation.equals("Herr")) {
            userSalutationID = 0;
        } else if (userSalutation.equals("Frau")) {
            userSalutationID = 1;
        } else {
            userSalutationID = 0;
        }

        return userSalutationID;
    }

    /**
     * Returns a UserState object.
     * @param userState userState
     * @return UserState
     */
    private UserState getUserState(final String userState) {
        UserState resState;

        if (userState.equals("DELETED")) {
            resState = UserState.DELETED;
        } else if (userState.equals("BLOCKED")) {
            resState = UserState.BLOCKED;
        } else if (userState.equals("ACTIVE")) {
            resState = UserState.ACTIVE;
        } else {
            resState = UserState.BLOCKED;
        }

        return resState;
    }

    /**
     * Gets the ID of the given UserState.
     * @param userState current userState
     * @return userState ID
     */
    private int getUserStateID(final UserState userState) {
        int userStateID;

        if (userState.name().equals("DELETED")) {
            userStateID = 2;
        } else if (userState.name().equals("BLOCKED")) {
            userStateID = 0;
        } else if (userState.name().equals("ACTIVE")) {
            userStateID = 1;
        } else {
            userStateID = 0;
        }

        return userStateID;
    }

    /**
     * Reset all Fields.
     */
    private void newAddress() {
        textFieldAddressNr.setText("");
        textFieldStreet.setText("");
        textFieldZIP.setText("");
        textFieldLocation.setText("");
        comboBoxAddressOption.setSelectedIndex(0);
    }

    /**
     * Reset all Fields.
     */
    private void newUser() {
        textFieldCustomerNr.setText("");
        textFieldUsername.setText("");
        textFieldName.setText("");
        textFieldPrename.setText("");

        comboBoxRole.setSelectedIndex(0);
        comboBoxState.setSelectedIndex(0);
        comboBoxSalutation.setSelectedIndex(0);
    }

    /**
     * Refresh all Address Fields.
     * @param addressId addressId
     */
    private void selectAddress(final int addressId) {
        AddressDto address = UserManagementConsumerImpl.getInstance().getAddress(addressId);

        if (address == null) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim selektieren des Users aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }

        textFieldAddressNr.setText(Integer.toString(address.getId()));
        textFieldStreet.setText(address.getStreet());
        textFieldZIP.setText(Integer.toString(address.getZipCode()));
        textFieldLocation.setText(address.getPlace());
        comboBoxAddressOption.setSelectedIndex(address.getType());
    }

    /**
     * Refresh all Fields.
     * @param userId ID from user
     */
    private void selectUser(final int userId) {
        UserDto activeUser = UserManagementConsumerImpl.getInstance().getUserById(userId);

        if (activeUser == null) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim selektieren des Users aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }

        textFieldCustomerNr.setText(Integer.toString(activeUser.getId()));
        textFieldUsername.setText(activeUser.getLogin());
        textFieldName.setText(activeUser.getSurname());
        textFieldPrename.setText(activeUser.getPrename());

        comboBoxRole.setSelectedIndex(getUserRoleID(activeUser.getRole()));
        comboBoxState.setSelectedIndex(getUserStateID(activeUser.getState()));
        comboBoxSalutation.setSelectedIndex(getUserSalutationID(activeUser.getSalutation()));

    }
}
